package java.awt.datatransfer;

import java.io.IOException;
import java.io.StringReader;

public class StringSelection implements Transferable, ClipboardOwner
{
    private static final int STRING = 0;
    private static final int PLAIN_TEXT = 1;
    private static final DataFlavor[] flavors;
    private String data;
    
    public StringSelection(String data) {
        this.data = data;
    }
    
    @Override
    public DataFlavor[] getTransferDataFlavors() {
        return (DataFlavor[])(DataFlavor[])StringSelection.flavors.clone();
    }
    
    @Override
    public boolean isDataFlavorSupported(DataFlavor dataFlavor) {
        int i = 0;
        while (i < StringSelection.flavors.length) {
            if (dataFlavor.equals(StringSelection.flavors[i])) {
                return true;
            }
            ++i;
        }
        return false;
    }
    
    @Override
    public Object getTransferData(DataFlavor dataFlavor) throws UnsupportedFlavorException, IOException {
        if (dataFlavor.equals(StringSelection.flavors[0])) {
            return this.data;
        }
        if (dataFlavor.equals(StringSelection.flavors[1])) {
            return new StringReader((this.data == null) ? "" : this.data);
        }
        throw new UnsupportedFlavorException(dataFlavor);
    }
    
    @Override
    public void lostOwnership(Clipboard clipboard, Transferable transferable) {
    }
    
    static {
        flavors = new DataFlavor[] { DataFlavor.stringFlavor, DataFlavor.plainTextFlavor };
    }
}
